comment #
*************************************************
*						*
*    f`kAZu[	GAL16V8/20V8/22V10	*
*    (C)ChaN, 1995-1997				*
*						*
*************************************************

ăAZuɂ OPTASMKvB
>optasm fgal; /ml

#

include	stddef.inc
include	str.inc
include	file.inc

.model t
.data

;-------------------------------
; foCX֘A̒`

GAL22		equ	0	; foCXʃtO
GAL16		equ	1
GAL20		equ	2

ARC_22		equ	0	; GAL22V10
ARC_SIM		equ	1	; simple mode (16/20)
ARC_CMP		equ	2	; complex mode (16/20)
ARC_REG		equ	3	; registered mode (16/20)

ROW16		equ	32	; ̓C (16V8)
ROW20		equ	40	;              (20V8)
ROW22		equ	44	;              (22V10)

ROW_ACW		equ	60	; ACW̍sAhX (16/20)
ROW_PRT		equ	61	; Protect fuse̍sAhX (16/20)
ROW_ERA		equ	63	; Erace fuse̍sAhX (16/20)

F_ACW16		equ	ROW16*64; Fuse map  ACẄʒu (16V8)
F_ACW20		equ	ROW20*64;                       (20V8)
F_ACW22		equ	ROW22*132;                      (22V10)

FNUM16		equ	2194	; Fuse (16V8)
FNUM20		equ	2706	;        (20V8)
FNUM22		equ	5892	;        (22V10)


MESSAGE		macro	msc	; bZ[Wo
		mov	ah,msc
		 call	DISP_MES
		endm


;-----------------------------------------------;
; sԍ̓Cԍϊe[u
;
; 0..38: input line# (inverted:+1)
; -1   : can't input
;OLMC# : -1:input only, 0..9:OLMC#

;GAL16V8	pin#	 1  2  3  4  5  6  7  8  9 10  11 12 13 14 15 16 17 18 19 20
LineTbl16	db	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, -1, 7, 6, 5, 4, 3, 2, 1, 0,-1 ; OLMC#
		db	 2, 0, 4, 8,12,16,20,24,28,-1, 30,26,22,18,-1,-1,14,10, 6,-1 ; simple mode
		db	 2, 0, 4, 8,12,16,20,24,28,-1, 30,-1,26,22,18,14,10, 6,-1,-1 ; complex mode
		db	-1, 0, 4, 8,12,16,20,24,28,-1, -1,30,26,22,18,14,10, 6, 2,-1 ; registered mode

;GAL20V8	pin#	 1  2  3  4  5  6  7  8  9 10 11 12  13 14 15 16 17 18 19 20 21 22 23 24
LineTbl20	db	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, -1,-1, 7, 6, 5, 4, 3, 2, 1, 0,-1,-1 ; OLMC#
		db	 2, 0, 4, 8,12,16,20,24,28,32,36,-1, 38,34,30,26,22,-1,-1,18,14,10, 6,-1 ; simple mode
		db	 2, 0, 4, 8,12,16,20,24,28,32,36,-1, 38,34,-1,30,26,22,18,14,10,-1, 6,-1 ; complex mode
		db	-1, 0, 4, 8,12,16,20,24,28,32,36,-1, -1,38,34,30,26,22,18,14,10, 6, 2,-1 ; registered mode

;GAL22V10	pin#	 1  2  3  4  5  6  7  8  9 10 11 12  13 14 15 16 17 18 19 20 21 22 23 24
LineTbl22	db	-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1, -1, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,-1 ; OLMC#
		db	 0, 4, 8,12,16,20,24,28,32,36,40,-1, 42,38,34,30,26,22,18,14,10, 6, 2,-1

;			 0  1  2  3  4  5  6  7  8  9	  OLMC#
RowTbl22	db	 1,10,21,34,49,66,83,98,111,122	; Product term number
		db	 8,10,12,14,16,16,14,12,10, 8	; Number of product terms

;-----------------------------------------------;
; JEDECt@Cp

CheckSum	dw	0		; o̓t@C̃`FbNT

Hd16		db	2,CR,LF,'GAL16V8*QP20*QF2194*',CR,LF,'G0*',CR,LF,'F0*',CR,LF
Hd20		db	2,CR,LF,'GAL20V8*QP24*QF2706*',CR,LF,'G0*',CR,LF,'F0*',CR,LF
Hd22		db	2,CR,LF,'GAL22V10*QP24*QF5892*',CR,LF,'G0*',CR,LF,'F0*',CR,LF

HexChar		db	'0123456789ABCDEF'



;-----------------------------------------------;
; bZ[W

DEB		equ	1	; 
MS_OPN		equ	3	; 
MS_USE		equ	4	; 
MS_CMP		equ	5	; 

ER_NS		equ	10	; 
ER_PIN		equ	11	; 
ER_SN		equ	12	; 
ER_ND		equ	13	; 
ER_DD		equ	14	; 
ER_NI		equ	15	; 
ER_FIL		equ	16	; 
ER_FOL		equ	22	; 
ER_DUP		equ	17	; 
ER_OE		equ	18	; 
ER_OE		equ	18	; 
ER_NOP		equ	19	; 
ER_NOL		equ	20	; 
ER_RGO		equ	21	; 
ER_NOD		equ	23	; 
ER_NF		equ	24	; 


MessStr		db	MS_OPN,	 'FGAL - Fast GAL assembler for GAL16V8/20V8/22V10%n'
		db		 '       R0.04a (C)ChaN,1995-1997%n%n',0
		db	MS_USE,	 'usage: fgal <source file>%n',0
		db	MS_CMP,	 'Assembly completed.%n',0
		db	ER_FIL,  '%sCannot open source file.%n',0
		db	ER_NOD,  '%sNot found device definition.%n',0
		db	ER_FOL,  '%sCannot open destination file.%n',0
		db	ER_NS,   '%sNot supported device. (%i)%n',0
		db	ER_NF,   '%sNot supported function. (%i)%n',0
		db	ER_PIN,  '%sIlligal pin name definition. (%i)%n',0
		db	ER_SN,   '%sSyntax error. (%i)%n',0
		db	ER_ND,   '%sNot defined pin name ??? (%i)%n',0
		db	ER_DD,   '%sDuplicated output pin definition. (%i)%n',0
		db	ER_NI,   '%sCannot use input mode. (%i)%n',0
		db	ER_DUP,  '%sDuplicated pin name. (%i)%n',0
		db	ER_RGO,  '%sCannot use registerd output with OE control. (%i)%n',0
		db	ER_OE,   '%sCannot use negative OE/AR/SP control. (%i)%n',0
		db	ER_NOP,  '%sThis pin cannot configure output mode. (%i)%n',0
		db	ER_NOL,  '%sToo many product lines. (%i)%n',0

		db	-1,	'???',0
MessErr		db	'Error: ',0


ModeStr		db	'Device: GAL%i%s%n',0
Ms_Sim		db	'V8 simple mode',0
Ms_Cmp		db	'V8 complex mode',0
Ms_Reg		db	'V8 registered mode',0
Ms_22		db	'V10',0

JedExt		db	'.JED',0


;-----------------------------------------------;
; foCX֘A

Device		db	?		; device type
ArcMode		db	0		; architecture control
WorkOlmc	dw	?		; working OLMC# (0..9)
WorkTerm	dw	?		; working product term (0..131)
TermCnt		db	?		; left of the product term

					; OLMC [htOrbg蓖
M_OUT		equ	BIT0		; Output
M_DIR		equ	BIT1		; Direct output
M_REG		equ	BIT2		; Registered output
M_INV		equ	BIT3		; Invert
M_OE		equ	BIT4		; OE control
M_RS		equ	BIT5		; Async reset
M_PS		equ	BIT6		; Sync preset

OlmcFlag	db	10 dup(0)	; OLMC [htOe[u


;-----------------------------------------------;
; V{EL[[he[uAt[Y}bv
;

KW_CHIP		equ	81h	; L[[hԍ
KW_GAL16	equ	82h
KW_GAL20	equ	83h
KW_GAL22	equ	90h
KW_EQU   	equ	84h
KW_FNC   	equ	85h
KW_EQR   	equ	86h
KW_EQB   	equ	87h
KW_PLS   	equ	88h
KW_AND   	equ	89h
KW_NC   	equ	8ah
KW_NOT   	equ	8bh
KW_TRST   	equ	8ch
KW_GND   	equ	8eh
KW_VCC   	equ	8fh

KW_SSET   	equ	98h
KW_ARST   	equ	99h

KwdTbl		db	KW_EQR,   ':=',0
		db	KW_EQB,   '=',0
		db	KW_PLS,   '+',0
		db	KW_AND,   '*',0
		db	KW_NOT,   '/',0
		db	KW_NC,    '-',0
		db	KW_NC,    'NC',0
		db	KW_GND,   'GND',0
		db	KW_VCC,   'VCC',0
		db	KW_CHIP,  'CHIP',0
		db	KW_ARST,  'ASYNC.RESET',0
		db	KW_SSET,  'SYNC.PRESET',0
		db	KW_TRST,  '.TRST',0
		db	KW_GAL16, 'GAL16V8',0
		db	KW_GAL20, 'GAL20V8',0
		db	KW_GAL22, 'GAL22V10',0
		db	KW_EQU,   'EQUATIONS',0
		db	KW_FNC,   'FUNCTION',0
		db	0

PinTbl		db	300 dup(?)	; h^ns̃V{e[u
FuseMap		db	6000 dup(?)	; t[Y}bv


;-----------------------------------------------;
; t@C삻̑

TextBuff	db	8000 dup(?)	; t@Ch^nobt@

Argc		db	?
Argv		dw	?


;----------------------------------------------------------------------------;
; vOR[h

.186
.code
		DEF_PSP			; PSP ̒`
start:		cld
		MESSAGE  MS_OPN
		GET_CMD_PAR  Argc,Argv
	_if e, Argc,0
		MESSAGE  MS_USE
		$DOS  4ch,-1
	_endif
		FIL_STR <ofs FuseMap>,<size FuseMap>,0

		 call	READ_SRC	; \[Xt@C̓ǂݍ
		 call	CVT_CHAR	; RgACAPSϊ
		 call	DEF_PIN		; sV{`
		 call	CHK_ARC		; A[LeN`
		 call	MAKE_FUSE	; t[Yf[^쐬
		 call	DISP_JED	; JEDECt@Co

		MESSAGE  MS_CMP
		$DOS  4ch,0		; I


mes_err:	mov	ah,ER_SN	; @G[
		jmp	err_end
mes_ndef:	mov	ah,ER_ND	; `V{
		jmp	err_end
mes_nod:	mov	ah,ER_NOD	; foCX̒`
		jmp	err_end
mes_nsup:	mov	ah,ER_NS	; T|[gfoCX
		jmp	err_end
mes_ppin:	mov	ah,ER_PIN	; s̕sK
		jmp	err_end
mes_dup:	mov	ah,ER_DUP	; s̏d`
		jmp	err_end
mes_dop:	mov	ah,ER_DD	; o̓s̏d`
		jmp	err_end
mes_roe:	mov	ah,ER_OE	; nd䂪_
		jmp	err_end
mes_nin:	mov	ah,ER_NI	; ͂łȂs
		jmp	err_end
mes_nop:	mov	ah,ER_NOP	; o̓sł͂Ȃ
		jmp	err_end
mes_nol:	mov	ah,ER_NOL	; nqȂ
		jmp	err_end
mes_rgo:	mov	ah,ER_RGO	; ndEWX^̓`
		jmp	err_end
mes_nof:	mov	ah,ER_NF	; gpłȂ@\
		jmp	err_end

err_end:	 call	DISP_MES
		$DOS  4ch,-1


;--------------------------------------;
; bZ[Wo
;
; Call	ah = message code

DISP_MES	proc
		mov	di,si
		mov	si,ofs MessStr
	_repeat
		lodsb
	 _break e, al,ah
	 _break e, al,-1
	 _repeat
		lodsb
	 _rept ne, al,0
	_rept
		mov	bx,si
		mov	si,ofs TextBuff
		mov	ax,1
	_repeat
		cmp	bptr[si],CR
	 @if e,<inc	ax>
		inc	si
	_rept b, si,di
		mov	bp,sp
		push	bx,ofs MessErr,ax
		 call	PRINTF
		ret
		PRINTF_F
DISP_MES	endp



;-----------------------------------------------;
; idcdbt@Co


DISP_JED	proc
		clr	di	; buffer write ptr

		; wb_o
	_case e, Device, GAL16
		mov	si,ofs Hd16
		mov	cx,size Hd16
	_case e, Device, GAL20
		mov	si,ofs Hd20
		mov	cx,size Hd20
	_default	;GAL22
		mov	si,ofs Hd22
		mov	cx,size Hd22
	_endc
	_repeat
		lodsb
		 call	DISP
	_loop

		; t[Y}bvo
		clr	si
	_if e, Device, GAL22			; GAL22V10
	 _repeat 132				; PT
		push	cx
		mov	cx,ROW22
		 call	DP_MAP
		pop	cx
	 _loop
		mov	cx,20			; ACW
		 call	DP_MAP
		mov	cx,64			; ES
		 call	DP_MAP

	_else					; GAL16V8, GAL20V8
	 _repeat 64				; PT
		push	cx
		cmp	Device,GAL16
		mov	cx,ROW16
 	 @ifn e,<mov	cx,ROW20>
		 call	DP_MAP
		pop	cx
	 _loop
		mov	cx,8			; XOR
		 call	DP_MAP
		mov	cx,64			; ES
		 call	DP_MAP
		mov	cx,8			; ACW1
		 call	DP_MAP
		mov	cx,64			; PTD
		 call	DP_MAP
		mov	cx,2			; SYN,AC0
		 call	DP_MAP
	_endif
		 call	DP_CSUM			; FUSE CHECK SUM
		 call	DP_DSUM			; FILE CHECK SUM
		 call	WRITE_BUFF		; t@Cɏo
		ret
DISP_JED	endp


DP_MAP		proc			; q[Y}bv̕\
		push	cx,si
	_repeat
		mov	al,FuseMap[si]
		inc	si
	 _break ne, al,0
	_loop
		pop	si,cx
	_if e
		add	si,cx
		ret
	_endif
		mov	al,'L'
		 call	DISP
		mov	ax,si
		 call	DP_DEC
		mov	al,' '
		 call	DISP
	_repeat				; fuse data
		mov	al,FuseMap[si]
		inc	si
		add	al,'0'
		 call	DISP
	_loop
		 call	DP_DELIM
		ret
DP_MAP		endp

DP_CSUM		proc			; q[Ỹ`FbNT
		mov	al,'C'
		 call	DISP
		 call	GET_FSUM
		 call	DP_HEX		; check sum
		 call	DP_DELIM
		ret
DP_CSUM		endp


DP_DSUM		proc			; f[^̃`FbNT
		mov	al,3
		 call	DISP
		mov	dx,CheckSum
		 call	DP_HEX
		mov	al,CR
		 call	DISP
		mov	al,LF
		 call	DISP
		ret
DP_DSUM		endp


GET_FSUM	proc			; t[Ỹ`FbNT
	_case e, Device, GAL16
		mov	cx,FNUM16
	_case e, Device, GAL20
		mov	cx,FNUM20
	_default	;GAL22
		mov	cx,FNUM22
	_endc
		clr	si
		clr	dx
		mov	ax,0001h
	_repeat
		tst	FuseMap[si]
	 @ifn z,<add	dx,ax>
		inc	si
		rol	al,1
	_loop
		ret
GET_FSUM	endp

DP_HEX		proc			; PUio	DX
		 call	dph
		 call	dph
		 call	dph
	dph:	rol	dx,4
		mov	al,dl
		and	al,0fh
		mov	bx,ofs HexChar
		xlat
		 call	DISP
		ret
DP_HEX		endp


DP_DEC		proc			; POio	AX
		push	cx
		mov	bp,10
	_repeat 4
		clr	dx
		div	bp
		push	dx
	_loop
	_repeat 4
		pop	ax
		add	al,'0'
		 call	DISP
	_loop
		pop	cx
		ret
DP_DEC		endp


DP_DELIM	proc			; f~^
		mov	al,'*'
		 call	DISP
		mov	al,CR
		 call	DISP
		mov	al,LF
		 call	DISP
		ret
DP_DELIM	endp


DISP		proc			; LN^o
		clr	ah
		add	CheckSum,ax
		mov	TextBuff[di],al
		inc	di
		ret
DISP		endp


WRITE_BUFF	proc			; obt@t@Cɏ
		push	di
		mov	di,Argv[0]
	_repeat
	 _break e, bptr[di],0
	 _break e, bptr[di],'.'
		inc	di
	_rept
		CPY_STR <ofs JedExt>,<>
		MAKE_FILE  0,Argv[0]
	_if c
		MESSAGE  ER_FOL
		$DOS  4ch,-1
	_endif
		pop	cx
		WRITE_FILE ax,<ofs TextBuff>,<>
		CLOSE_FILE
		ret
WRITE_BUFF	endp



;-----------------------------------------------;
; V{EL[[h


ADD_SYM		proc			; V{ǉ
		push	dx
		mov	di,ofs PinTbl
	_repeat ne, wptr[di],0
		inc	di
	_rept
		inc	di
		stosb
	_repeat
		movsb
		 call	CHK_CHR
	_rept e, dl,0
		pop	dx
		ret
ADD_SYM		endp


SCH_SYM		proc			; V{̃T[`
		push	dx,cx,di
		mov	cx,si
		mov	di,ofs PinTbl[1]
	_repeat
		mov	si,cx
	 _if e, bptr[di],0
		or	al,-1
		pop	di,cx,dx
		ret
	 _endif
		mov	ah,[di]
		inc	di
	 _repeat
		mov	al,[di]
	  _break ne, al,[si]
		inc	di
		inc	si
	 _rept
	 _repeat
		inc	di
	 _rept ne, bptr[di][-1],0
	 _cont ne, al,0
		 call	CHK_CHR
	_rept e, dl,0
		mov	al,ah
		clr	ah
		pop	di,cx,dx
		ret
SCH_SYM		endp


SCH_KWD		proc			; L[[h̃T[`
		push	cx,dx,di
		mov	cx,si
		 call	CHK_CHR
		mov	dh,dl
		mov	di,ofs KwdTbl
	_repeat
		mov	si,cx
		mov	ah,[di]
		inc	di
	 _if e, ah,0		; Not found
		or	al,-1
		pop	di,dx,cx
		ret
	 _endif
	 _repeat
		mov	al,[di]
	  _break ne, al,[si]
		inc	di
		inc	si
	 _rept
	 _repeat
		inc	di
	 _rept ne, bptr[di][-1],0
	 _cont ne, al,0
		 call	CHK_CHR
	_rept e, dl,dh
		mov	al,ah
		clr	ah
		pop	di,dx,cx
		ret
SCH_KWD		endp


JMP_NEXT	proc			; ̃[hփWv
	_repeat 
		mov	al,[si]
	 _break e, al,EOF
	 _break be, al,' '
		inc	si
	_rept
		; to next
JMP_NEXT	endp

SKIP_SPC	proc			; Xy[X̓ǂݔ΂
	_repeat
		mov	al,[si]
	 _break e, al,EOF
	 _break a, al,' '
		inc	si
	_rept
		ret
SKIP_SPC	endp

SKIP_SPCE	proc
		 call	SKIP_SPC
		cmp	al,EOF
		je	mes_err
		ret
SKIP_SPCE	endp


CHK_CHR		proc			; LN^`FbN@0:p, 1:LP, 2:LQ, 3:
		mov	al,[si]
		clr	dl
	_if ae, al,'@'
		ret be, al,'Z'
	_endif
	_if ae, al,'0'
		ret be, al,'9'
	_endif
		inc	dl
	_skip e, al,'/'
	 _skip e, al,'.'
		inc	dl
	  _skip a, al,' '
		inc	dl
	___endif
		ret
CHK_CHR		endp


;-----------------------------------------------;
; \[Xt@C TextBuffɓǂݍ

READ_SRC	proc
	_if c,<OPEN_FILE  0,Argv[0]>
		MESSAGE  ER_FIL
		$DOS  4ch,-1
	_endif
		READ_FILE  ax,<ofs TextBuff>,<size TextBuff-1>
		mov	si,ax
		mov	TextBuff[si],EOF
		CLOSE_FILE
		ret
READ_SRC	endp


;-----------------------------------------------;
; ǂݍ񂾃t@C̃Rg


CVT_CHAR	proc
		mov	si,ofs TextBuff
		mov	di,si
	_repeat
		lodsb
	 _if e, al,';'
	  _repeat
		mov	al,' '
		stosb
		lodsb
	   _break e, al,EOF
	  _rept ne, al,CR
	 _endif
		stosb
	_rept ne, al,EOF
		ret
CVT_CHAR	endp


;-----------------------------------------------;
; foCX^Cv(16V8/20V8/22V10)̃`FbN
; h^ns̃V{o^
;
;Ret	SI -> EQUATIONSoʒu


DEF_PIN		proc
		FIL_STR  <ofs PinTbl>,<size PinTbl>,0
		mov	si,ofs TextBuff
	_repeat				; CHIP܂œǂݔ΂
		 call	SCH_KWD
	 _break e, al,KW_CHIP
		 call	JMP_NEXT
		cmp	al,EOF
		je	mes_nod
	_rept

		 call	JMP_NEXT	; foCX^Cvݒ
		 call	JMP_NEXT
		 call	SCH_KWD
	_case e, al,KW_GAL16
		mov	Device,GAL16
	_case e, al,KW_GAL20
		mov	Device,GAL20
	_case e, al,KW_GAL22
		mov	Device,GAL22
	_default
		jmp	mes_nsup
	_endc

	_if e, Device,GAL16		; s`
		mov	dl,10
		mov	dh,20
	_else
		mov	dl,12
		mov	dh,24
	_endif
		clr	cx
	_repeat
		inc	cl
		 call	JMP_NEXT
		cmp	al,EOF
		je	mes_err
		 call	SCH_KWD
	 _case e, cl,dl		; GND pin
		cmp	al,KW_GND
		jne	mes_ppin
	 _case e, cl,dh		; VCC pin
		cmp	al,KW_VCC
		jne	mes_ppin
	 _default		; I/O pin
	  _if e, al,-1
		 call	SCH_SYM
		jz	mes_dup
		mov	al,cl
		 call	ADD_SYM
	  _else
		cmp	al,KW_NC
		jne	mes_ppin
	  _endif
	 _endc
	_rept b, cl,dh

		 call	JMP_NEXT		; EQUATIONS ?
		 call	SCH_KWD
		jnz	mes_err
		ret
DEF_PIN		endp


;-----------------------------------------------;
; A[LeN`̌(16V8/20V8)ƃG[`FbNB
; RróAWX^o͂̎gp󋵂A[LeN
; `肵ɏ]t[Y}bvB
;
;Call	SI -> EQUATIONS̎


CHK_ARC		proc
		push	si

	_if e, Device, GAL22		; GAL22V10
		FIL_STR <ofs FuseMap[F_ACW22]>,20,1
	 _while
		 call	SKIP_SPC
	  _break e, al,EOF
	  _if nz,<call	SCH_KWD>
	   _if nz,<call	SCH_SYM>
		 call	CHK_CHR
		cmp	dl,0
		je	mes_ndef
		jmp	mes_err
	  __endif
	 _rept ne, al,KW_FNC

	_else				; GAL16V8/20V8
		clr	dx
	 _while
		 call	SKIP_SPC
	  _break e, al,EOF
	  _if nz,<call	SCH_KWD>
	   _if nz,<call	SCH_SYM>
		 call	CHK_CHR
		cmp	dl,0
		je	mes_ndef
		jmp	mes_err
	  __endif
	  _break e, al,KW_FNC
	  _case e, al,KW_EQR
		set	dh
	  _case e, al,KW_TRST
		set	dl
	  _endc
	 _rept
		mov	al,ARC_SIM
	 _if nz,<tst dl>		; nd䂠H
		mov	al,ARC_CMP
	 _endif
	 _if nz,<tst dh>		; WX^o͂H
		mov	al,ARC_REG
	 _endif
		mov	ArcMode,al

		cmp	Device,GAL16	; t[Y}bv̏ (AND/OR line = 0)
		mov	di,ofs FuseMap[F_ACW16]
	 @ifn e,<mov	di,ofs FuseMap[F_ACW20]>
		FIL_STR <>,8,1		; XOR = 1
		FIL_STR <>,64,0		; SIGNATURE = 0
		FIL_STR <>,8,1		; AC1 = 1
		FIL_STR <>,64,1		; PTD = 1
		clr	ax
		cmp	ArcMode,ARC_REG	; SYN
	 @ifn e,<mov	al,1>
		cmp	ArcMode,ARC_SIM	; AC0
	 @ifn e,<mov	ah,1>
		stosw
	_endif

		mov	bp,sp		; foCX^Cv̕\
		push	ofs ModeStr
	_case e, Device, GAL16
		push	16
	_case e, Device, GAL20
		push	20
	_default	;GAL22
		push	22
	_endc
	_case e, ArcMode,ARC_SIM
		push	ofs Ms_Sim
	_case e, ArcMode,ARC_CMP
		push	ofs Ms_Cmp
	_case e, ArcMode,ARC_REG
		push	ofs Ms_Reg
	_default	;ARC_22
		push	ofs Ms_22
	_endc
		 call	PRINTF

		pop	si
		ret
CHK_ARC		endp


;-----------------------------------------------;
; t[Yf[^쐬B
; 
;Call	SI -> EQUATIONS̎
;

MAKE_FUSE	proc
	_repeat
		push	si
		 call	SKIP_SPC
		 call	SCH_KWD
		pop	si
	 _break e, al,KW_FNC			; FUNCTION ?
	 	 call	GET_OUTPUT
	 _break c				; <EOF> ?
		 call	ENB_OLMC
		 call	ENB_PT
	 _repeat
		 call	GET_INPUT
	  _case e, Device,GAL16
		imul	di,WorkTerm,ROW16
		mov	cx,ROW16
	  _case e, Device,GAL20
		imul	di,WorkTerm,ROW20
		mov	cx,ROW20
	  _default	 ;GAL22
		imul	di,WorkTerm,ROW22
		mov	cx,ROW22
	  _endc
		clr	bx
	  _case e, al,KW_VCC			; Not effective
	  _case e, al,KW_GND			; Disable product term
	   _repeat
		mov	FuseMap[di][bx],0
		inc	bx
	   _loop
	  _default				; Connect to input line
		mov	bl,al
		mov	FuseMap[di][bx],0
	  _endc
	  _break c,<call GET_LOGI>		; Continue ?
	  _cont e, al,KW_AND
		inc	WorkTerm ; KW_PLS
		dec	TermCnt
		jz	mes_nol
		 call	ENB_PT
	 _rept
	_rept

	_if e, Device, GAL22		; Trim feedback polarity
		clr	di
	 _repeat 132
		push	cx
		mov	bx,2
		clr	si
	  _repeat 10
		mov	al,OlmcFlag[si]
		and	al,M_REG+M_INV
	   _if e, al,M_REG		; registered and not invert ?
		mov	ax,wptr FuseMap[di][bx]
		xchg	ah,al
		mov	wptr FuseMap[di][bx],ax
	   _endif
		add	bx,4
		inc	si
	  _loop
		pop	cx
		add	di,ROW22
	 _loop
	_endif
		ret
MAKE_FUSE	endp


;-------------------------------;
; o̓sinklbԍjǂ
;
;Call	SI = buffer ptr
;
;Ret	CF = set on EOF
;	CF = clr on successful
;	  SI = next ptr
;	  AL = OLMC [htO
;	  WorkOlmc = OLMC#:0..9, (Unknown if A.RS/S.PS term)

GET_OUTPUT	proc
		 call	SKIP_SPC
	_if e, al,EOF
		stc
		ret
	_endif
		push	bx,dx
		clr	dx
		 call	SCH_KWD
	_if e, al,KW_NOT
		mov	dl,M_INV
		 call	SKIP_SPCE
		 call	SCH_KWD
	_endif
	_skip e, al,KW_SSET
		cmp	al,KW_ARST
	_endif
	_if e
		mov	dh,al
		cmp	Device,GAL22
		jne	mes_nof
		 call	SKIP_SPCE
		 call	SCH_KWD
		cmp	al,KW_EQB
		jne	mes_err
		cmp	dh,KW_ARST
	 	mov	al,M_PS
	 @if e,<mov	al,M_RS>

	_else
		cmp	al,-1
		jne	mes_err
		 call	SCH_SYM
		jnz	mes_err
		mov	bx,ax
	 _case e, Device, GAL16
		mov	al,LineTbl16[bx-1]
	 _case e, Device, GAL20
		mov	al,LineTbl20[bx-1]
	 _default	;GAL22
		mov	al,LineTbl22[bx-1]
	 _endc
		cmp	al,-1
		je	mes_nop
		clr	ah
		mov	WorkOlmc,ax
		 call	SKIP_SPCE
		 call	SCH_KWD
	 _case e, al,KW_TRST
		 call	SKIP_SPCE
		 call	SCH_KWD
		cmp	al,KW_EQB
		jne	mes_err
		mov	al,M_OE

	 _case e, al,KW_EQR
		mov	al,M_OUT+M_REG

	 _case e, al,KW_EQB
		mov	al,M_OUT+M_DIR

	 _default
		jmp	mes_err
	 _endc
	_endif
		or	al,dl
		pop	dx,bx
		clc
		ret
GET_OUTPUT	endp



;-------------------------------;
; ̓siCԍjǂ
;
;Call	SI = buffer ptr
;
;Ret	SI = next ptr
;	AL = Line#:0..43, KW_VCC, KW_GND

GET_INPUT	proc
		push	bx,dx
		clr	dx
		 call	SKIP_SPCE
		 call	SCH_KWD
	_if e, al,KW_NOT
		mov	dl,1
		 call	SKIP_SPCE
		 call	SCH_KWD
	_endif
	_case e, al,KW_VCC
		pop	dx,bx
		ret
	_case e, al,KW_GND
		pop	dx,bx
		ret
	_endc
		cmp	al,-1
		jne	mes_err
		 call	SCH_SYM
		jnz	mes_err
		clr	bx
		mov	bl,ArcMode
	_case e, Device, GAL16
		imul	bx,20
		add	bx,ax
		mov	al,LineTbl16[bx][-1]
	_case e, Device, GAL20
		imul	bx,24
		add	bx,ax
		mov	al,LineTbl20[bx][-1]
	_default	;GAL22
		addi	bx,ax,24
		mov	al,LineTbl22[bx][-1]
	_endc
		cmp	al,-1
		je	mes_nin
		add	al,dl
		pop	dx,bx
		ret
GET_INPUT	endp


;-------------------------------;
; _Zqǂ
;
;Call	SI = buffer ptr
;
;Ret	CF = set on error
;	  SI = not chenged
;	CF = clr on successful
;	  SI = next ptr
;	  AL = KW_PLS, KW_AND

GET_LOGI	proc
		push	si
		 call	SKIP_SPC
		 call	SCH_KWD
	_case e, al,KW_PLS
		add	sp,2
		clc
	_case e, al,KW_AND
		add	sp,2
		clc
	_default
		pop	si
		stc
	_endc
		ret
GET_LOGI	endp


;-------------------------------;
; nklbo̓[hɐݒ
;
;Call	WorkOlmc = OLMC# (0..9)
;	AL = OLMC [htO
;
;Ret	WorkTerm = product term#
;	TermCnt = number of product term

ENB_OLMC	proc
		pusha
	_if nz,<test al,M_RS+M_PS>		; A.RS/S.PS ?
		test	al,M_INV
		jnz	mes_roe
		test	al,M_PS
		mov	WorkTerm,0
	 @ifn z,<mov	WorkTerm,131>
		mov	TermCnt,1
		popa
		ret
	_endif
		mov	bx,WorkOlmc
	_if e, Device, GAL22
		mov	di,F_ACW22
		shl	bx,1
		test	al,M_INV
	 @ifn z,<mov	FuseMap[di][bx][0],0>
		shr	bx,1
	_else
		cmp	Device,GAL16
		mov	di,F_ACW16
	 @ifn e,<mov	di,F_ACW20>
		test	al,M_INV
	 @ifn z,<mov	FuseMap[di][bx],0>
		shl	bx,3
		mov	WorkTerm,bx
		shr	bx,3
	_endif
		test	OlmcFlag[bx],al
		jnz	mes_dop
		set	OlmcFlag[bx],al


	_case e, ArcMode,ARC_22			; GAL22V10
		clr	ch
		mov	cl,RowTbl22[bx]
		mov	WorkTerm,cx
	 _if nz,<test al,M_OE>		; OE ctrl
		test	al,M_INV
		jnz	mes_roe
		mov	TermCnt,1
	 _else
		test	OlmcFlag[bx],M_OE
	  @if z,<call	ENB_PT>
		inc	WorkTerm
		mov	cl,RowTbl22[bx][10]
		mov	TermCnt,cl
	  _if nz,<test al,M_REG>	; registered output
	  	shl	bx,1
		mov	FuseMap[di][bx][1],0
		shr	bx,1
	  _endif
	 _endif

	_case e, ArcMode,ARC_SIM		; GAL16/20 Simple mode
		mov	FuseMap[di][8+64][bx],0
		mov	TermCnt,8

	_case e, ArcMode,ARC_CMP		; GAL16/20 Complex mode
	 _if nz,<test al,M_OE>		; OE ctrl
		test	al,M_INV
		jnz	mes_roe
		mov	TermCnt,1
	 _else				; direct output
		test	OlmcFlag[bx],M_OE
	  @if z,<call	ENB_PT>
		inc	WorkTerm
		mov	TermCnt,7
	 _endif

	_case e, ArcMode,ARC_REG		; GAL16/20 Registered mode
	 _if nz,<test al,M_OE>		; OE ctrl
		test	al,M_INV
		jnz	mes_roe
		test	OlmcFlag[bx],M_REG
		jnz	mes_rgo
		 call	ENB_PT
		mov	TermCnt,1
	 _else
	  _if nz,<test al,M_DIR>	; direct output
		test	OlmcFlag[bx],M_OE
	   @if z,<call	ENB_PT>
		inc	WorkTerm
		mov	TermCnt,7
	  _else				; registered output
		test	OlmcFlag[bx],M_OE
		jnz	mes_rgo
		mov	FuseMap[di][8+64][bx],0
		mov	TermCnt,8
	 __endif

	_endc
		popa
		ret
ENB_OLMC	endp


;-------------------------------;
; _ύ̗L (ڑSĐ؂)
;
;Call	WorkTerm = product term# (0..131)

ENB_PT		proc
		pusha
	_case e, Device, GAL16
		mov	cx,ROW16
	_case e, Device, GAL20
		mov	cx,ROW20
	_default	;GAL22
		mov	cx,ROW22
	_endc
		mov	ax,WorkTerm
		mul	cl
		add	ax,ofs FuseMap
		FIL_STR ax,<>,1
		popa
		ret
ENB_PT		endp


		$end	start
